'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _polished = require('polished');

var _theme = require('../../theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var charcoal100 = _theme2.default.colors.primary.charcoal;
var charcoal70 = (0, _polished.transparentize)(0.3, charcoal100);
var charcoal50 = (0, _polished.transparentize)(0.5, charcoal100);
var charcoal20 = (0, _polished.transparentize)(0.8, charcoal100);

var dotSpinnerAnimation = (0, _styledComponents.keyframes)(['0%,100%{box-shadow:0em -2.6em 0em 0em ', ',1.8em -1.8em 0 0em ', ',2.5em 0em 0 0em ', ',1.75em 1.75em 0 0em ', ',0em 2.5em 0 0em ', ',-1.8em 1.8em 0 0em ', ',-2.6em 0em 0 0em ', ',-1.8em -1.8em 0 0em ', ';}12.5%{box-shadow:0em -2.6em 0em 0em ', ',1.8em -1.8em 0 0em ', ',2.5em 0em 0 0em ', ',1.75em 1.75em 0 0em ', ',0em 2.5em 0 0em ', ',-1.8em 1.8em 0 0em ', ',-2.6em 0em 0 0em ', ',-1.8em -1.8em 0 0em ', ';}25%{box-shadow:0em -2.6em 0em 0em ', ',1.8em -1.8em 0 0em ', ',2.5em 0em 0 0em ', ',1.75em 1.75em 0 0em ', ',0em 2.5em 0 0em ', ',-1.8em 1.8em 0 0em ', ',-2.6em 0em 0 0em ', ',-1.8em -1.8em 0 0em ', ';}37.5%{box-shadow:0em -2.6em 0em 0em ', ',1.8em -1.8em 0 0em ', ',2.5em 0em 0 0em ', ',1.75em 1.75em 0 0em ', ',0em 2.5em 0 0em ', ',-1.8em 1.8em 0 0em ', ',-2.6em 0em 0 0em ', ',-1.8em -1.8em 0 0em ', ';}50%{box-shadow:0em -2.6em 0em 0em ', ',1.8em -1.8em 0 0em ', ',2.5em 0em 0 0em ', ',1.75em 1.75em 0 0em ', ',0em 2.5em 0 0em ', ',-1.8em 1.8em 0 0em ', ',-2.6em 0em 0 0em ', ',-1.8em -1.8em 0 0em ', ';}62.5%{box-shadow:0em -2.6em 0em 0em ', ',1.8em -1.8em 0 0em ', ',2.5em 0em 0 0em ', ',1.75em 1.75em 0 0em ', ',0em 2.5em 0 0em ', ',-1.8em 1.8em 0 0em ', ',-2.6em 0em 0 0em ', ',-1.8em -1.8em 0 0em ', ';}75%{box-shadow:0em -2.6em 0em 0em ', ',1.8em -1.8em 0 0em ', ',2.5em 0em 0 0em ', ',1.75em 1.75em 0 0em ', ',0em 2.5em 0 0em ', ',-1.8em 1.8em 0 0em ', ',-2.6em 0em 0 0em ', ',-1.8em -1.8em 0 0em ', ';}87.5%{box-shadow:0em -2.6em 0em 0em ', ',1.8em -1.8em 0 0em ', ',2.5em 0em 0 0em ', ',1.75em 1.75em 0 0em ', ',0em 2.5em 0 0em ', ',-1.8em 1.8em 0 0em ', ',-2.6em 0em 0 0em ', ',-1.8em -1.8em 0 0em ', ';}'], charcoal100, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal50, charcoal70, charcoal70, charcoal100, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal50, charcoal50, charcoal70, charcoal100, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal50, charcoal70, charcoal100, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal50, charcoal70, charcoal100, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal50, charcoal70, charcoal100, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal50, charcoal70, charcoal100, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal20, charcoal50, charcoal70, charcoal100);

var DotSpinner = _styledComponents2.default.div.withConfig({
  displayName: 'CircularProgress__DotSpinner'
})(['border-radius:50%;position:relative;text-indent:-9999em;-webkit-animation:', ' 1.1s infinite ease;animation:', ' 1.1s infinite ease;-webkit-transform:translateZ(0);-ms-transform:translateZ(0);transform:translateZ(0);', ';'], dotSpinnerAnimation, dotSpinnerAnimation, function (props) {
  return props.scale && '\n    margin: ' + 15 * props.scale + 'px;\n    font-size: ' + 5 * props.scale + 'px;\n    width: ' + 5 * props.scale + 'px;\n    height: ' + 5 * props.scale + 'px;\n  ';
});

var ProgressContainer = _styledComponents2.default.div.withConfig({
  displayName: 'CircularProgress__ProgressContainer'
})(['display:inline-block;']);

var ProgressWrapper = _styledComponents2.default.div.withConfig({
  displayName: 'CircularProgress__ProgressWrapper'
})(['width:', 'px;height:', 'px;', ' ', ';'], function (props) {
  return props.size;
}, function (props) {
  return props.size;
}, function (props) {
  return props.inline && '\n    display: inline-block;\n    vertical-align: middle;\n  ';
}, function (props) {
  return props.center && '\n    margin-left: auto;\n    margin-right: auto;\n  ';
});

/**
 * Size is set in px
 * ```javascript
 * import React from 'react';
 * import { CircularProgress } from 'weaveworks-ui-components'
 *
 * React.render(
 *   <div>
 *     <CircularProgress size={35} />
 *     <CircularProgress inline /> Inline
 *     <CircularProgress center />
 *   </div>
 * );
 * ```
 */
var CircularProgress = function CircularProgress(props) {
  return _react2.default.createElement(
    ProgressWrapper,
    props,
    _react2.default.createElement(
      ProgressContainer,
      null,
      _react2.default.createElement(DotSpinner, { scale: props.size / 35 })
    )
  );
};

CircularProgress.propTypes = {
  /** Size of spinner in px */
  size: _propTypes2.default.number,
  /** Whether to display the spinner inline */
  inline: _propTypes2.default.bool,
  /** Whether to center the spinner horizontally */
  center: _propTypes2.default.bool
};

CircularProgress.defaultProps = {
  size: 30,
  inline: false,
  center: false
};

exports.default = CircularProgress;