'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  border-width: 1px 0 0 0;\n'], ['\n  border-width: 1px 0 0 0;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  border-width: 0 0 0 1px;\n'], ['\n  border-width: 0 0 0 1px;\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  top: -8px;\n  right: 5px;\n'], ['\n  top: -8px;\n  right: 5px;\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n  top: ', 'px;\n  left: 0;\n'], ['\n  top: ', 'px;\n  left: 0;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var AxesGridContainer = _styledComponents2.default.div.withConfig({
  displayName: '_AxesGrid__AxesGridContainer'
})(['']);

var AxisLine = _styledComponents2.default.div.attrs({
  style: function style(_ref) {
    var _ref$width = _ref.width,
        width = _ref$width === undefined ? 0 : _ref$width,
        _ref$height = _ref.height,
        height = _ref$height === undefined ? 0 : _ref$height;
    return { width: width, height: height };
  }
}).withConfig({
  displayName: '_AxesGrid__AxisLine'
})(['border-style:dashed;border-color:', ';position:absolute;left:0;top:0;'], function (props) {
  return props.theme.colors.alto;
});

var HorizontalLine = AxisLine.extend(_templateObject);

var VerticalLine = AxisLine.extend(_templateObject2);

var TickContainer = _styledComponents2.default.div.attrs({
  style: function style(_ref2) {
    var _ref2$left = _ref2.left,
        left = _ref2$left === undefined ? 0 : _ref2$left,
        _ref2$top = _ref2.top,
        top = _ref2$top === undefined ? 0 : _ref2$top;
    return { left: left, top: top };
  }
}).withConfig({
  displayName: '_AxesGrid__TickContainer'
})(['position:absolute;']);

var TickLabel = _styledComponents2.default.span.withConfig({
  displayName: '_AxesGrid__TickLabel'
})(['color:', ';display:block;font-size:12px;position:absolute;white-space:nowrap;'], function (props) {
  return props.theme.colors.dimGray;
});

var ValueTickLabel = TickLabel.extend(_templateObject3);

var TimeTickLabel = TickLabel.extend(_templateObject4, function (props) {
  return props.height + 5;
});

function formatTimeTick(timeSec) {
  var timestamp = (0, _moment2.default)(timeSec * 1000).utc();

  // Show month and day at every full day.
  var startOfDay = timestamp.clone().startOf('day');
  if (timestamp.diff(startOfDay) === 0) {
    return timestamp.format('MMM DD');
  }

  // Show hour and minute at every full minute.
  var startOfMinute = timestamp.clone().startOf('minute');
  if (timestamp.diff(startOfMinute) === 0) {
    return timestamp.format('HH:mm');
  }

  // Otherwise show only the seconds context.
  return timestamp.format("ss'");
}

function getTimeTicksBetween(startTimeSec, endTimeSec) {
  // 1s, 2s, 5s, 15s, 30s, 1min, 2min, 5min, 15min, 30min, 1h, 2h, 4h, 8h intervals
  var stepsSec = [1, 2, 5, 15, 30, 60, 120, 300, 900, 1800, 3600, 7200, 14400, 28800];

  // Tweak the step to show a reasonable number of ticks.
  var stepSec = (0, _lodash.find)(stepsSec, function (s) {
    return (endTimeSec - startTimeSec) / s < 8;
  });

  // Round up the time ticks to the time ticks step precision.
  var initialTickSec = Math.ceil(startTimeSec / stepSec) * stepSec;
  return (0, _lodash.range)(initialTickSec, endTimeSec, stepSec);
}

function getValueTicks(metricUnits, maxValue) {
  /* eslint-disable no-restricted-properties */
  var powersOf10 = (0, _lodash.range)(-6, 15).map(function (p) {
    return Math.pow(10, p);
  });
  var steps = metricUnits !== 'bytes' ? (0, _lodash.flatMap)(powersOf10, function (p) {
    return [p, 2 * p, 5 * p];
  }) : (0, _lodash.range)(50).map(function (p) {
    return Math.pow(2, p);
  });
  /* eslint-enable no-restricted-properties */

  var step = (0, _lodash.find)(steps, function (s) {
    return maxValue / s < 4;
  });
  return (0, _lodash.range)(0, maxValue, step);
}

var AxesGrid = function (_React$PureComponent) {
  _inherits(AxesGrid, _React$PureComponent);

  function AxesGrid() {
    _classCallCheck(this, AxesGrid);

    return _possibleConstructorReturn(this, (AxesGrid.__proto__ || Object.getPrototypeOf(AxesGrid)).apply(this, arguments));
  }

  _createClass(AxesGrid, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          chartWidth = _props.chartWidth,
          chartHeight = _props.chartHeight,
          timeScale = _props.timeScale,
          valueScale = _props.valueScale,
          metricUnits = _props.metricUnits,
          hasData = _props.hasData;

      if (!chartWidth || !chartHeight || !hasData) return null;

      var yAxisMax = valueScale.domain()[1];

      var _timeScale$domain = timeScale.domain(),
          _timeScale$domain2 = _slicedToArray(_timeScale$domain, 2),
          startTimeSec = _timeScale$domain2[0],
          endTimeSec = _timeScale$domain2[1];

      var timeTicks = getTimeTicksBetween(startTimeSec, endTimeSec);
      var valueTicks = getValueTicks(metricUnits, yAxisMax);
      var formatValue = this.props.valueFormatter(yAxisMax);

      return _react2.default.createElement(
        AxesGridContainer,
        null,
        valueTicks.map(function (value) {
          return _react2.default.createElement(
            TickContainer,
            { key: value, top: valueScale(value) },
            _react2.default.createElement(HorizontalLine, { width: chartWidth }),
            _react2.default.createElement(
              ValueTickLabel,
              null,
              formatValue(value)
            )
          );
        }),
        timeTicks.map(function (timeSec) {
          return _react2.default.createElement(
            TickContainer,
            { key: timeSec, left: timeScale(timeSec) },
            _react2.default.createElement(VerticalLine, { height: chartHeight }),
            _react2.default.createElement(
              TimeTickLabel,
              { height: chartHeight },
              formatTimeTick(timeSec)
            )
          );
        })
      );
    }
  }]);

  return AxesGrid;
}(_react2.default.PureComponent);

AxesGrid.propTypes = {
  hasData: _propTypes2.default.bool.isRequired,
  chartWidth: _propTypes2.default.number.isRequired,
  chartHeight: _propTypes2.default.number.isRequired,
  timeScale: _propTypes2.default.func.isRequired,
  valueScale: _propTypes2.default.func.isRequired,
  valueFormatter: _propTypes2.default.func.isRequired,
  metricUnits: _propTypes2.default.string.isRequired
};

exports.default = AxesGrid;