'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TooltipContainer = _styledComponents2.default.div.attrs({
  // Using attrs prevents extensive styled components
  // generation every time the tooltip is repositioned.
  style: function style(_ref) {
    var x = _ref.x,
        y = _ref.y;
    return { left: x, top: y };
  }
}).withConfig({
  displayName: '_Tooltip__TooltipContainer'
})(['color:', ';background-color:', ';border:1px solid ', ';border-radius:', ';padding:10px 15px;position:absolute;margin-top:20px;margin-left:10px;pointer-events:none;min-width:250px;max-width:500px;opacity:0.95;z-index:5;'], function (props) {
  return props.theme.colors.primary.charcoal;
}, function (props) {
  return props.theme.colors.lightgray;
}, function (props) {
  return props.theme.colors.silverDark;
}, function (props) {
  return props.theme.borderRadius;
});

var Timestamp = _styledComponents2.default.div.withConfig({
  displayName: '_Tooltip__Timestamp'
})(['font-family:\'Roboto\',sans-serif;font-size:13px;margin-bottom:8px;']);

var Tooltip = function (_React$PureComponent) {
  _inherits(Tooltip, _React$PureComponent);

  function Tooltip() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, Tooltip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call.apply(_ref2, [this].concat(args))), _this), _this.saveTooltipRef = function (ref) {
      _this.tooltipRef = ref;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Tooltip, [{
    key: 'getTooltipBoundingRect',
    value: function getTooltipBoundingRect() {
      return this.tooltipRef ? this.tooltipRef.getBoundingClientRect() : { width: 0, height: 0, top: 0, left: 0 };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          x = _props.x,
          y = _props.y,
          timestamp = _props.timestamp,
          graphWidth = _props.graphWidth;

      var tooltipWidth = this.getTooltipBoundingRect().width;
      var clampedX = Math.min(x, graphWidth - tooltipWidth - 10);

      return _react2.default.createElement(
        TooltipContainer,
        { x: clampedX, y: y, innerRef: this.saveTooltipRef },
        _react2.default.createElement(
          Timestamp,
          null,
          (0, _moment2.default)(timestamp).utc().format(),
          ' ',
          'UTC'
        ),
        this.props.children
      );
    }
  }]);

  return Tooltip;
}(_react2.default.PureComponent);

Tooltip.propTypes = {
  graphWidth: _propTypes2.default.number.isRequired,
  timestamp: _propTypes2.default.string.isRequired,
  x: _propTypes2.default.number.isRequired,
  y: _propTypes2.default.number.isRequired
};

exports.default = Tooltip;