'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HEIGHT_PX = 27;

var RangeSelectorWrapper = _styledComponents2.default.div.withConfig({
  displayName: '_RangeSelector__RangeSelectorWrapper'
})(['border-left:1px solid ', ';min-width:75px;'], function (props) {
  return props.theme.colors.silverDark;
});

var SelectedRangeWrapper = _styledComponents2.default.div.withConfig({
  displayName: '_RangeSelector__SelectedRangeWrapper'
})(['background-color:transparent;cursor:pointer;font-family:\'Roboto\',sans-serif;font-size:1rem;padding:3px 8px;display:flex;justify-content:space-between;line-height:21px;']);

var SelectedRange = _styledComponents2.default.div.withConfig({
  displayName: '_RangeSelector__SelectedRange'
})(['color:', ';'], function (props) {
  return props.theme.colors.primary.charcoal;
});

var RangeOptionsListWrapper = _styledComponents2.default.div.withConfig({
  displayName: '_RangeSelector__RangeOptionsListWrapper'
})(['position:fixed;top:0;bottom:0;right:0;left:0;z-index:3000;']);

var RangeOptionsList = _styledComponents2.default.div.withConfig({
  displayName: '_RangeSelector__RangeOptionsList'
})(['background-color:', ';border:1px solid ', ';color:', ';box-sizing:border-box;position:absolute;text-align:left;'], function (props) {
  return props.theme.colors.white;
}, function (props) {
  return props.theme.colors.silverDark;
}, function (props) {
  return props.theme.colors.primary.charcoal;
});

var CaretIconsContainer = _styledComponents2.default.span.withConfig({
  displayName: '_RangeSelector__CaretIconsContainer'
})(['display:flex;flex-direction:column;justify-content:center;margin-left:8px;.fa{font-size:12px;line-height:7px;}']);

var RangeOption = _styledComponents2.default.div.withConfig({
  displayName: '_RangeSelector__RangeOption'
})(['line-height:', 'px;cursor:pointer;padding:0 8px;&:hover{background-color:', ';}', ';'], HEIGHT_PX, function (props) {
  return props.theme.colors.lightgray;
}, function (props) {
  return props.selected && '\n    color: ' + props.theme.colors.accent.blue + ';\n  ';
});

var rangeOptions = [{ label: '15min', valueMs: _moment2.default.duration(15, 'minutes').asMilliseconds() }, { label: '30min', valueMs: _moment2.default.duration(30, 'minutes').asMilliseconds() }, { label: '1h', valueMs: _moment2.default.duration(1, 'hour').asMilliseconds() }, { label: '3h', valueMs: _moment2.default.duration(3, 'hours').asMilliseconds() }, { label: '6h', valueMs: _moment2.default.duration(6, 'hours').asMilliseconds() }, { label: '24h', valueMs: _moment2.default.duration(24, 'hours').asMilliseconds() }];

var RangeSelector = function (_React$Component) {
  _inherits(RangeSelector, _React$Component);

  function RangeSelector(props, context) {
    _classCallCheck(this, RangeSelector);

    var _this = _possibleConstructorReturn(this, (RangeSelector.__proto__ || Object.getPrototypeOf(RangeSelector)).call(this, props, context));

    _this.state = {
      isOpen: false
    };

    _this.saveNodeRef = _this.saveNodeRef.bind(_this);
    _this.handleDropDownClick = _this.handleDropDownClick.bind(_this);
    _this.handleBackgroundClick = _this.handleBackgroundClick.bind(_this);
    return _this;
  }

  _createClass(RangeSelector, [{
    key: 'handleDropDownClick',
    value: function handleDropDownClick() {
      this.setState({ isOpen: true });
    }
  }, {
    key: 'handleBackgroundClick',
    value: function handleBackgroundClick() {
      this.setState({ isOpen: false });
    }
  }, {
    key: 'saveNodeRef',
    value: function saveNodeRef(ref) {
      this.containerRef = ref;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var rangeMs = this.props.rangeMs;
      var isOpen = this.state.isOpen;


      var selectedRangeIndex = rangeOptions.findIndex(function (r) {
        return r.valueMs === rangeMs;
      });
      var selectedRangeLabel = rangeOptions.find(function (r) {
        return r.valueMs === rangeMs;
      }).label;
      var anchorEl = this.containerRef && this.containerRef.getBoundingClientRect();
      var menuStyle = anchorEl ? {
        top: anchorEl.top - selectedRangeIndex * HEIGHT_PX - 1,
        left: anchorEl.right - anchorEl.width,
        minWidth: anchorEl.width + 1
      } : {};

      return _react2.default.createElement(
        RangeSelectorWrapper,
        { innerRef: this.saveNodeRef },
        _react2.default.createElement(
          SelectedRangeWrapper,
          { onClick: this.handleDropDownClick },
          _react2.default.createElement(
            SelectedRange,
            null,
            selectedRangeLabel
          ),
          _react2.default.createElement(
            CaretIconsContainer,
            null,
            _react2.default.createElement('span', { className: 'fa fa-caret-up' }),
            _react2.default.createElement('span', { className: 'fa fa-caret-down' })
          )
        ),
        isOpen && _react2.default.createElement(
          RangeOptionsListWrapper,
          { onClick: this.handleBackgroundClick },
          _react2.default.createElement(
            RangeOptionsList,
            { style: menuStyle },
            rangeOptions.map(function (_ref) {
              var valueMs = _ref.valueMs,
                  label = _ref.label;
              return _react2.default.createElement(
                RangeOption,
                {
                  key: valueMs,
                  selected: valueMs === rangeMs,
                  onClick: function onClick() {
                    return _this2.props.onChange(valueMs);
                  }
                },
                label
              );
            })
          )
        )
      );
    }
  }]);

  return RangeSelector;
}(_react2.default.Component);

RangeSelector.propTypes = {
  rangeMs: _propTypes2.default.number.isRequired,
  onChange: _propTypes2.default.func.isRequired
};

exports.default = RangeSelector;