'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TimelineRange = function TimelineRange(_ref) {
  var color = _ref.color,
      timeScale = _ref.timeScale,
      startAt = _ref.startAt,
      endAt = _ref.endAt,
      width = _ref.width,
      height = _ref.height;

  var endShift = endAt ? timeScale((0, _moment2.default)(endAt)) : width;
  var startShift = startAt ? timeScale((0, _moment2.default)(startAt)) : -width;

  // If the range interval is very short or we're zoomed out a lot, render the
  // interval as at least 4 pixels wide. Then re-adjust the left end of the
  // interval to account for the calibrated min-width.
  var length = Math.max(4, endShift - startShift);
  startShift = endShift - length;

  return _react2.default.createElement('rect', {
    fill: color,
    fillOpacity: 0.15,
    transform: 'translate(' + startShift + ', 0)',
    width: length,
    height: height
  });
};

TimelineRange.propTypes = {
  color: _propTypes2.default.string.isRequired,
  timeScale: _propTypes2.default.func.isRequired,
  startAt: _propTypes2.default.string,
  endAt: _propTypes2.default.string,
  width: _propTypes2.default.number.isRequired,
  height: _propTypes2.default.number.isRequired
};

exports.default = TimelineRange;