'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TimestampInputWrapper = _styledComponents2.default.div.withConfig({
  displayName: '_TimestampInput__TimestampInputWrapper'
})(['font-size:13px;align-items:baseline;padding:3px 8px;pointer-events:all;opacity:0.8;display:flex;']);

var TimestampInputContainer = _styledComponents2.default.input.withConfig({
  displayName: '_TimestampInput__TimestampInputContainer'
})(['background-color:transparent;font-family:\'Roboto\',sans-serif;margin-right:3px;text-align:center;font-size:1rem;width:165px;border:0;outline:0;']);

var TimestampInput = function (_React$PureComponent) {
  _inherits(TimestampInput, _React$PureComponent);

  function TimestampInput(props, context) {
    _classCallCheck(this, TimestampInput);

    var _this = _possibleConstructorReturn(this, (TimestampInput.__proto__ || Object.getPrototypeOf(TimestampInput)).call(this, props, context));

    _this.state = {
      timestamp: props.timestamp
    };

    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  _createClass(TimestampInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var timestamp = nextProps.timestamp;

      if (timestamp !== this.props.timestamp) {
        this.setState({ timestamp: timestamp });
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(ev) {
      var timestamp = ev.target.value;
      this.setState({ timestamp: timestamp });

      if ((0, _moment2.default)(timestamp).isValid()) {
        this.props.onChangeTimestamp(timestamp);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        TimestampInputWrapper,
        null,
        _react2.default.createElement(TimestampInputContainer, {
          value: this.state.timestamp,
          onChange: this.handleChange,
          disabled: this.props.disabled
        }),
        ' ',
        'UTC'
      );
    }
  }]);

  return TimestampInput;
}(_react2.default.PureComponent);

TimestampInput.propTypes = {
  timestamp: _propTypes2.default.string.isRequired,
  onChangeTimestamp: _propTypes2.default.func.isRequired,
  disabled: _propTypes2.default.bool
};

exports.default = TimestampInput;